package gov.va.cem.cbs.repo;

import gov.va.cem.cbs.model.MaterializedViews;

import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;
@Repository
@Transactional(readOnly=true)
public class MaterializedViewDaoImpl implements MaterializedViewDao {

	@PersistenceContext
	private EntityManager em;
	
	/**
	 * retrieve last refresh date of materialized view
	 */
	@Override
	public Date getLastRefreshDate(String viewName) {
		List<MaterializedViews> views = em.createNamedQuery("MaterializedViews.findLastRefresh", MaterializedViews.class)
		//.setParameter("owner", owner)
		.setParameter("name", viewName)
		.getResultList();
		
		MaterializedViews view = views.get(0);
		
		
		return view.getLastRefreshDate();
	}

}
