/*
Please adjust the parameters as needed
Drop MV - needs owner
Create MV - needs owner, dblink and refresh rate
View - needs owner

Below are example of refresh

on kskdev: @intr_schedule_mv "boss" "dev.qitcdev01.cem.domain" "refresh fast start with to_date(to_char(sysdate+1,'mm/dd/yyyy') || ' 22:00:00','/mm/dd/yyyy hh24:mi:ss') next sysdate + 1" 

so it won't refresh do on kskdev:
@intr_schedule_mv boss "dev.cem.domain" "never refresh" 

Note: You must connect as DBA role before running publicsynonym.sql

*/


ACCEPT boss_schema CHAR PROMPT 'Please Enter BOSS schema name (example - BOSSTRNG):  '
ACCEPT amas_schema CHAR PROMPT 'Please Enter AMAS schema name: (example - AMASR):  '

ACCEPT dblink_host CHAR PROMPT 'Please Enter Hostname for BOSS Source database (example (dev) - dev.qitcdev01.cem.domain): '
/* 
Drop MV Intr_Schedule
*/

@drop_intrsched_mv.sql &boss_schema


/*
Create MV Intr_Schedule and set to refresh every 10 minutes
for alpha and beta, use respective "boss" and "dev.qitcdev01.cem.domain"
alpha use "qitcalpha04.cem.domain"
*/

@alter_refresh_mv.sql &boss_schema "refresh fast NEXT SYSDATE+10/1440"


@intr_schedule_mv &boss_schema &dblink_host "refresh fast NEXT SYSDATE+10/1440" 


/**
Must be run before the views to run without error
*/
@grant_state_province &boss_schema "sys_user" &amas_schema

/*
Create View
*/

@burialschedule_view &boss_schema
@cemetery_view &boss_schema

/*
Analyze tables
*/
@analyze

/* 
Grants
*/

@grant_mv &boss_schema

--conn /as sysdba

@publicsynonym &boss_schema